
function duplicate() {
    var desc1 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putClass(app.stringIDToTypeID("document"));
    desc1.putReference(app.stringIDToTypeID("null"), ref1);
    var ref2 = new ActionReference();
    ref2.putEnumerated(app.stringIDToTypeID("layer"), app.stringIDToTypeID("ordinal"), app.stringIDToTypeID("targetEnum"));
    desc1.putReference(app.stringIDToTypeID("using"), ref2);
    desc1.putInteger(app.stringIDToTypeID("version"), 5);
    app.executeAction(app.stringIDToTypeID("make"), desc1, DialogModes.NO);
}


function trim() {
    var desc1 = new ActionDescriptor();
    desc1.putEnumerated( stringIDToTypeID( "trimBasedOn" ), stringIDToTypeID( "trimBasedOn" ), stringIDToTypeID( "transparency" ) );
    desc1.putBoolean( stringIDToTypeID( "top" ), true );
    desc1.putBoolean( stringIDToTypeID( "bottom" ), true );
    desc1.putBoolean( stringIDToTypeID( "left" ), true );
    desc1.putBoolean( stringIDToTypeID( "right" ), true );
    executeAction( stringIDToTypeID( "trim" ), desc1, DialogModes.NO );

}

function output() {
    var options = new ExportOptionsSaveForWeb();
    options.format = SaveDocumentType.PNG;
    options.PNG8 = false;
    options.transparency = true;
    options.interlaced = false;

    app.activeDocument.exportDocument(new File(Folder.desktop.absoluteURI + "/demo.png"), ExportType.SAVEFORWEB, options);
}

duplicate();
trim();
output();

